## Despawn Tag
execute as @e[tag=despawn] run event entity @s despawn

## Help Tag
execute as @a[tag=npcHelp] at @s run function custom_npcs/help

#### Toggles

scoreboard objectives add npcTimer dummy
scoreboard players add @e[type=npc:player] npcTimer 0
scoreboard players add @e[type=npc:player,scores={npcTimer=0..10}] npcTimer 1

execute as @e[scores={npcTimer=..10}] at @s run function custom_npcs/toggles/defaults

## Base Health [DONE]

# 10hp
execute as @e[type=npc:player,tag=10hp] run event entity @s 10hp
effect @e[tag=10hp] instant_health 1 255 true
tag @e[type=npc:player] remove 10hp

# 20hp
execute as @e[type=npc:player,tag=20hp] run event entity @s 20hp
effect @e[tag=20hp] instant_health 1 255 true
tag @e[type=npc:player] remove 20hp

# 40hp
execute as @e[type=npc:player,tag=40hp] run event entity @s 40hp
effect @e[tag=40hp] instant_health 1 255 true
tag @e[type=npc:player] remove 40hp

# 100hp
execute as @e[type=npc:player,tag=100hp] run event entity @s 100hp
effect @e[tag=100hp] instant_health 1 255 true
tag @e[type=npc:player] remove 100hp

## Base Damage [DONE]

# 1 damage
execute as @e[type=npc:player,tag=1dmg] run event entity @s 1dmg
tag @e[type=npc:player,tag=1dmg] add 1Damage
tag @e[type=npc:player,tag=1dmg] remove 5Damage
tag @e[type=npc:player,tag=1dmg] remove 10Damage
tag @e[type=npc:player,tag=1dmg] remove 20Damage
tag @e[type=npc:player] remove 1dmg

# 5 damage
execute as @e[type=npc:player,tag=5dmg] run event entity @s 5dmg
tag @e[type=npc:player,tag=5dmg] add 5Damage
tag @e[type=npc:player,tag=5dmg] remove 1Damage
tag @e[type=npc:player,tag=5dmg] remove 20Damage
tag @e[type=npc:player,tag=5dmg] remove 10Damage
tag @e[type=npc:player] remove 5dmg

# 10 damage
execute as @e[type=npc:player,tag=10dmg] run event entity @s 10dmg
tag @e[type=npc:player,tag=10dmg] add 10Damage
tag @e[type=npc:player,tag=10dmg] remove 20Damage
tag @e[type=npc:player,tag=10dmg] remove 5Damage
tag @e[type=npc:player,tag=10dmg] remove 10Damage
tag @e[type=npc:player] remove 10dmg

# 20 damage
execute as @e[type=npc:player,tag=20dmg] run event entity @s 20dmg
tag @e[type=npc:player,tag=20dmg] add 20Damage
tag @e[type=npc:player,tag=20dmg] remove 10Damage
tag @e[type=npc:player,tag=20dmg] remove 5Damage
tag @e[type=npc:player,tag=20dmg] remove 1Damage
tag @e[type=npc:player] remove 20dmg

### Boss [DONE]

## isBoss
execute as @e[type=npc:player,tag=isBoss] run event entity @s is_boss
tag @e[type=npc:player] remove isBoss

## notBoss
scoreboard objectives add notBossDelay dummy
execute as @e[type=npc:player,tag=notBoss] run event entity @s not_boss
execute as @e[c=1,type=npc:player,tag=notBoss] run function custom_npcs/toggles/notBoss

## NPC Components [Done]

# isNPC
execute as @e[type=npc:player,tag=isNPC] run event entity @s is_npc
tag @e[type=npc:player] remove isNPC

# notNPC
execute as @e[type=npc:player,tag=notNPC] run event entity @s not_npc
tag @e[type=npc:player] remove notNPC

## Scales [Done]

# scale0.5
execute as @e[type=npc:player,tag=scale0.5] run event entity @s scale_0.5
tag @e[type=npc:player] remove scale0.5

# scale1.0
execute as @e[type=npc:player,tag=scale1.0] run event entity @s scale_1.0
tag @e[type=npc:player] remove scale1.0

# scale1.5
execute as @e[type=npc:player,tag=scale1.5] run event entity @s scale_1.5
tag @e[type=npc:player] remove scale1.5

## Movement Settings [Done]

# cantMove
execute as @e[type=npc:player,tag=cantMove] run event entity @s cant_move
tag @e[type=npc:player] remove cantMove

# neutral
execute as @e[type=npc:player,tag=neutral] run event entity @s neutral
tag @e[type=npc:player] remove neutral

# hostile
execute as @e[type=npc:player,tag=hostile] run event entity @s hostile
tag @e[type=npc:player] remove hostile

# defensive
execute as @e[type=npc:player,tag=defensive] run event entity @s defensive
tag @e[type=npc:player] remove defensive

## Movement Speed [DONE]

# fullSpeed
execute as @e[type=npc:player,tag=fullSpeed] run event entity @s fullSpeed
tag @e[type=npc:player] remove fullSpeed

# halfSpeed
execute as @e[type=npc:player,tag=halfSpeed] run event entity @s halfSpeed
tag @e[type=npc:player] remove halfSpeed

# defSpeed
execute as @e[type=npc:player,tag=defSpeed] run event entity @s defSpeed
tag @e[type=npc:player] remove defSpeed

## Immortality [Done]

# immortal
execute as @e[type=npc:player,tag=immortal] run event entity @s is_immortal
tag @e[type=npc:player] remove immortal

# mortal
execute as @e[type=npc:player,tag=mortal] run event entity @s not_immortal
tag @e[type=npc:player] remove mortal

## Name Visibility [Done]

# showName
execute as @e[type=npc:player,tag=showName] run event entity @s show_name
tag @e[type=npc:player] remove showName

# hideName
execute as @e[type=npc:player,tag=hideName] run event entity @s hide_name
tag @e[type=npc:player] remove hideName

## Push Settings [DONE]

# notPushable
execute as @e[type=npc:player,tag=notPushable] run event entity @s not_pushable
tag @e[type=npc:player] remove notPushable

# isPushable
execute as @e[type=npc:player,tag=isPushable] run event entity @s is_pushable
tag @e[type=npc:player] remove isPushable

## Knockback Settings [DONE]

# KB
execute as @e[type=npc:player,tag=KB] run event entity @s hasKB
tag @e[type=npc:player] remove KB

# halfKB
execute as @e[type=npc:player,tag=halfKB] run event entity @s halfKB
tag @e[type=npc:player] remove halfKB

# noKB
execute as @e[type=npc:player,tag=noKB] run event entity @s noKB
tag @e[type=npc:player] remove noKB